#!/usr/bin/env python

import sys
import math

PA_VOLUME_NORM = 0x10000

def percentage2sw(percentage):
    return float(percentage) / 100.0 * float(PA_VOLUME_NORM)

def percentage2linear(percentage):
    return sw2linear(percentage2sw(percentage))

def percentage2db(percentage):
    return linear2db(percentage2linear(percentage))

def sw2percentage(sw):
    return sw / float(PA_VOLUME_NORM) * 100.0

def sw2linear(sw):
    return (float(sw) / float(PA_VOLUME_NORM))**3

def sw2db(sw):
    return linear2db(sw2linear(sw))

def linear2percentage(linear):
    return sw2percentage(linear2sw(linear))

def linear2sw(linear):
    return round(linear**(1.0/3.0) * PA_VOLUME_NORM);

def linear2db(linear):
    return 20.0 * math.log10(linear);

def db2percentage(db):
    return sw2percentage(db2sw(db))

def db2sw(db):
    return linear2sw(db2linear(db))

def db2linear(db):
    return 10.0**(db / 20.0)

def percentage2sw(percentage):
    return float(percentage) / 100.0 * float(PA_VOLUME_NORM)

def percentage2linear(percentage):
    return sw2linear(percentage2sw(percentage))

def percentage2db(percentage):
    return linear2db(percentage2linear(percentage))

def sw2percentage(sw):
    return sw / float(PA_VOLUME_NORM) * 100.0

def sw2linear(sw):
    return (float(sw) / float(PA_VOLUME_NORM))**3

def sw2db(sw):
    return linear2db(sw2linear(sw))

def linear2percentage(linear):
    return sw2percentage(linear2sw(linear))

def linear2sw(linear):
    return round(linear**(1.0/3.0) * PA_VOLUME_NORM);

def linear2db(linear):
    return 20.0 * math.log10(linear);

def db2percentage(db):
    return sw2percentage(db2sw(db))

def db2sw(db):
    return linear2sw(db2linear(db))

def db2linear(db):
    return 10.0**(db / 20.0)

